Bug 860829 - Grub2 can't resolve names on F18
Grub2 can't resolve names on F18
Status: CLOSED CURRENTRELEASE
Product: Fedora
Classification: Fedora
Component: grub2 (Show other bugs)
18
ppc64 All
unspecified Severity medium
: ---
: ---
Assigned To: Peter Jones
Fedora Extras Quality Assurance
:
Depends On:
Blocks: F18Betappc
  Show dependency treegraph
 
Reported: 2012-09-26 16:02 EDT by IBM Bug Proxy
Modified: 2012-10-30 16:30 EDT (History)
8 users (show)

See Also:
Fixed In Version: grub2-2.00-10.fc18
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2012-10-30 16:30:43 EDT
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:


Attachments (Terms of Use)
Workaround to fix DNS lookup (ipv4 only) (1.86 KB, text/plain)
2012-09-28 17:00 EDT, IBM Bug Proxy
no flags Details
[PATCH] Issue separate DNS queries for ipv4 and ipv6 (7.45 KB, text/plain)
2012-10-16 11:01 EDT, IBM Bug Proxy
no flags Details


External Trackers
Tracker ID Priority Status Summary Last Updated
IBM Linux Technology Center 85566 None None None 2012-09-26 16:02:32 EDT

  None (edit)
Description IBM Bug Proxy 2012-09-26 16:02:32 EDT
Description of problem:

Grub2 on Fedora 18 has DNS support, however it does not work properly.
Going to the grub2's console I get the following:

grub> net_ls_dns
9.10.244.100
grub> 
grub> net_nslookup ibm.com
error: no DNS reply received.
grub> 
grub> net_nslookup ibm.com 9.10.244.100
error: no DNS record found.
grub> 

Version-Release number of selected component (if applicable):
grub2-2.00-8.fc18
BIND 9.4.3-P5

=====

Google's DNS server does resolve grub's queries, however I can't tell what DNS server they run. BIND is a largely used DNS server and should be supported.

grub> net_nslookup ibm.com 8.8.8.8
129.42.38.1
Comment 1 IBM Bug Proxy 2012-09-28 17:00:43 EDT
Created attachment 618761 [details]
Workaround to fix DNS lookup (ipv4 only)


------- Comment on attachment From gusld@br.ibm.com 2012-09-28 20:50 EDT-------


After some investigation I found that this issue is caused by GRUB2 assembling 2 questions (ipv4 and ipv6) on a single DNS packet.

BIND does not support it, and my tests suggest that dnsmasq also doesn't when resolving local domains.

The reason why BIND doesn't support multiple questions per query is due to potential ambiguity on partial results. You can find some discussions on the following links. These discussions are a bit old but I can confirm that latest stable release of BIND still doesn't support multiple questions per query.
https://lists.isc.org/pipermail/bind-users/2010-December/082304.html
http://stackoverflow.com/questions/4082081/requesting-a-and-aaaa-records-in-single-dns-query
https://groups.google.com/forum/?fromgroups=#!topic/comp.protocols.dns.bind/uOWxNkm7AVg

As a proof of concept, I've written and tested the attached patch which basically drops ipv6 question from GRUB's DNS queries. This makes ipv4 DNS work fine, though drops ipv6 DNS support.

I've only tested on ppc64, but this issue probably affects all arches, since the code is not arch-specific.

I will work on a more appropriate patch to make GRUB send 2 separate queries for ipv4 and ipv6. I would appreciate any comments/suggestions.
Comment 2 IBM Bug Proxy 2012-10-16 11:01:48 EDT
Created attachment 628205 [details]
[PATCH] Issue separate DNS queries for ipv4 and ipv6


------- Comment on attachment From gusld@br.ibm.com 2012-10-16 14:59 EDT-------


Sorry, forgot to mention the bugz number in the patch.
Comment 3 Fedora Update System 2012-10-18 14:07:18 EDT
grub2-2.00-10.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/grub2-2.00-10.fc18
Comment 4 Fedora Update System 2012-10-19 11:41:25 EDT
Package grub2-2.00-10.fc18:
* should fix your issue,
* was pushed to the Fedora 18 testing repository,
* should be available at your local mirror within two days.
Update it with:
# su -c 'yum update --enablerepo=updates-testing grub2-2.00-10.fc18'
as soon as you are able to.
Please go to the following url:
https://admin.fedoraproject.org/updates/FEDORA-2012-16471/grub2-2.00-10.fc18
then log in and leave karma (feedback).
Comment 5 Fedora Update System 2012-10-22 15:53:41 EDT
grub2-2.00-11.fc18 has been submitted as an update for Fedora 18.
https://admin.fedoraproject.org/updates/grub2-2.00-11.fc18
Comment 6 Gustavo Luiz Duarte 2012-10-30 16:30:43 EDT
Tested grub2-2.00-11.fc18 and it works fine.

Note You need to log in before you can comment on or make changes to this bug.